Index: libs/openzap/mod_openzap/Makefile
===================================================================
--- libs/openzap/mod_openzap/Makefile	(revision 610)
+++ libs/openzap/mod_openzap/Makefile	(working copy)
@@ -1,7 +1,7 @@
 BASE=../../..
 OZ_DIR=..
 VERBOSE=1
-OZSO=$(OZ_DIR)/libopenzap.so
+OZSO=$(OZ_DIR)/libopenzap.la
 LOCAL_CFLAGS=-I$(OZ_DIR)/src/include -I$(OZ_DIR)/src/isdn/include
 LOCAL_LDFLAGS=-L$(OZ_DIR) -lopenzap 
 include $(BASE)/build/modmake.rules
Index: libs/openzap/Makefile.in
===================================================================
--- libs/openzap/Makefile.in	(revision 610)
+++ libs/openzap/Makefile.in	(working copy)
@@ -97,45 +97,45 @@
 
 
 OBJS=\
-$(SRC)/hashtable.o \
-$(SRC)/hashtable_itr.o \
-$(SRC)/zap_io.o \
-$(SRC)/zap_config.o \
-$(SRC)/zap_callerid.o \
-$(SRC)/fsk.o \
-$(SRC)/uart.o \
-$(SRC)/g711.o \
-$(SRC)/libteletone_detect.o \
-$(SRC)/libteletone_generate.o \
-$(SRC)/zap_buffer.o \
-$(SRC)/zap_threadmutex.o \
-$(SRC)/zap_dso.o
+$(SRC)/hashtable.lo \
+$(SRC)/hashtable_itr.lo \
+$(SRC)/zap_io.lo \
+$(SRC)/zap_config.lo \
+$(SRC)/zap_callerid.lo \
+$(SRC)/fsk.lo \
+$(SRC)/uart.lo \
+$(SRC)/g711.lo \
+$(SRC)/libteletone_detect.lo \
+$(SRC)/libteletone_generate.lo \
+$(SRC)/zap_buffer.lo \
+$(SRC)/zap_threadmutex.lo \
+$(SRC)/zap_dso.lo
 
 BOOST_OBJS=\
-$(SRC)/ozmod/ozmod_ss7_boost/ss7_boost_client.o \
-$(SRC)/ozmod/ozmod_ss7_boost/ozmod_ss7_boost.o
+$(SRC)/ozmod/ozmod_ss7_boost/ss7_boost_client.lo \
+$(SRC)/ozmod/ozmod_ss7_boost/ozmod_ss7_boost.lo
 
 ISDN_OBJS=\
-$(SRC)/isdn/EuroISDNStateNT.o \
-$(SRC)/isdn/EuroISDNStateTE.o \
-$(SRC)/isdn/mfifo.o \
-$(SRC)/isdn/Q921.o \
-$(SRC)/isdn/Q931api.o \
-$(SRC)/isdn/Q931.o \
-$(SRC)/isdn/Q931ie.o \
-$(SRC)/isdn/Q931mes.o \
-$(SRC)/isdn/Q931StateNT.o \
-$(SRC)/isdn/Q931StateTE.o \
-$(SRC)/isdn/nationalmes.o \
-$(SRC)/isdn/nationalStateNT.o \
-$(SRC)/isdn/nationalStateTE.o \
-$(SRC)/isdn/DMSmes.o \
-$(SRC)/isdn/DMSStateNT.o \
-$(SRC)/isdn/DMSStateTE.o \
-$(SRC)/isdn/5ESSmes.o \
-$(SRC)/isdn/5ESSStateNT.o \
-$(SRC)/isdn/5ESSStateTE.o \
-$(SRC)/isdn/Q932mes.o
+$(SRC)/isdn/EuroISDNStateNT.lo \
+$(SRC)/isdn/EuroISDNStateTE.lo \
+$(SRC)/isdn/mfifo.lo \
+$(SRC)/isdn/Q921.lo \
+$(SRC)/isdn/Q931api.lo \
+$(SRC)/isdn/Q931.lo \
+$(SRC)/isdn/Q931ie.lo \
+$(SRC)/isdn/Q931mes.lo \
+$(SRC)/isdn/Q931StateNT.lo \
+$(SRC)/isdn/Q931StateTE.lo \
+$(SRC)/isdn/nationalmes.lo \
+$(SRC)/isdn/nationalStateNT.lo \
+$(SRC)/isdn/nationalStateTE.lo \
+$(SRC)/isdn/DMSmes.lo \
+$(SRC)/isdn/DMSStateNT.lo \
+$(SRC)/isdn/DMSStateTE.lo \
+$(SRC)/isdn/5ESSmes.lo \
+$(SRC)/isdn/5ESSStateNT.lo \
+$(SRC)/isdn/5ESSStateTE.lo \
+$(SRC)/isdn/Q932mes.lo
 
 
 HEADERS= $(SRC)/include/fsk.h \
@@ -167,7 +167,7 @@
 $(SRC)/isdn/include/Q932.h 
 
 
-MYLIB=libopenzap.$(DYNAMIC_LIB_EXTEN)
+MYLIB=libopenzap.la
 PREFIX=@prefix@
 
 PIKA_DIR=$(shell ls -d /usr/include/pika 2>/dev/null)
@@ -241,45 +241,45 @@
 	@$(LTINSTALL) $(MYLIB) $(DESTDIR)$(PREFIX)/lib/
 	@mkdir -p $(DESTDIR)$(PREFIX)/mod
 	@[ ! -f ozmod_* ] || cp -f ozmod_* $(DESTDIR)$(PREFIX)/mod
-	@cp -f src/ozmod/*/*.$(DYNAMIC_LIB_EXTEN) $(DESTDIR)$(PREFIX)/mod
+	@cp -f src/ozmod/*/.libs/*.$(DYNAMIC_LIB_EXTEN) $(DESTDIR)$(PREFIX)/mod
 	@echo OpenZAP Installed
 
 uninstall:
 	@rm -fr $(DESTDIR)$(PREFIX)
 
 $(SRC)/ozmod/ozmod_skel/ozmod_skel.$(DYNAMIC_LIB_EXTEN): $(SRC)/ozmod/ozmod_skel/ozmod_skel.o $(MYLIB)
-	$(LINK) $(SOLINK) $(SRC)/ozmod/ozmod_skel/ozmod_skel.o $(MYLIB) -rpath $(libdir)
+	$(LINK) $(SOLINK) $(SRC)/ozmod/ozmod_skel/ozmod_skel.o $(MYLIB) -avoid-version -module -rpath $(libdir)
 skelmod: $(SRC)/ozmod/ozmod_skel/ozmod_skel.$(DYNAMIC_LIB_EXTEN)
 
 
 $(SRC)/ozmod/ozmod_zt/ozmod_zt.$(DYNAMIC_LIB_EXTEN): $(SRC)/ozmod/ozmod_zt/ozmod_zt.o $(MYLIB)
-	$(LINK) $(SOLINK) $(SRC)/ozmod/ozmod_zt/ozmod_zt.o $(MYLIB) -rpath $(libdir)
+	$(LINK) $(SOLINK) $(SRC)/ozmod/ozmod_zt/ozmod_zt.o $(MYLIB) -avoid-version -module -rpath $(libdir)
 ztmod: $(SRC)/ozmod/ozmod_zt/ozmod_zt.$(DYNAMIC_LIB_EXTEN)
 
 $(SRC)/ozmod/ozmod_wanpipe/ozmod_wanpipe.$(DYNAMIC_LIB_EXTEN): $(SRC)/ozmod/ozmod_wanpipe/ozmod_wanpipe.o $(MYLIB)
-	$(LINK) $(SOLINK) $(SRC)/ozmod/ozmod_wanpipe/ozmod_wanpipe.o $(MYLIB) -rpath $(libdir)
+	$(LINK) $(SOLINK) $(SRC)/ozmod/ozmod_wanpipe/ozmod_wanpipe.o $(MYLIB) -avoid-version -module -rpath $(libdir)
 wpmod: $(SRC)/ozmod/ozmod_wanpipe/ozmod_wanpipe.$(DYNAMIC_LIB_EXTEN)
 
 $(SRC)/ozmod/ozmod_pika/ozmod_pika.$(DYNAMIC_LIB_EXTEN): $(SRC)/ozmod/ozmod_pika/ozmod_pika.o $(MYLIB)
-	$(LINK) $(SOLINK) $(SRC)/ozmod/ozmod_pika/ozmod_pika.o  $(MYLIB) -rpath $(libdir)
+	$(LINK) $(SOLINK) $(SRC)/ozmod/ozmod_pika/ozmod_pika.o  $(MYLIB) -avoid-version -module -rpath $(libdir)
 pikamod: $(SRC)/ozmod/ozmod_pika/ozmod_pika.$(DYNAMIC_LIB_EXTEN)
 
 $(ISDN_OBJS): $(ISDN_HEADERS) $(ISDN_SOURCES) $(SRC)/ozmod/ozmod_isdn/ozmod_isdn.c
 
-$(SRC)/ozmod/ozmod_isdn/ozmod_isdn.$(DYNAMIC_LIB_EXTEN): $(MYLIB) $(ISDN_OBJS) $(SRC)/ozmod/ozmod_isdn/ozmod_isdn.o
-	$(LINK) $(SOLINK) $(ISDN_OBJS) $(SRC)/ozmod/ozmod_isdn/ozmod_isdn.o $(MYLIB) -rpath $(libdir)
+$(SRC)/ozmod/ozmod_isdn/ozmod_isdn.$(DYNAMIC_LIB_EXTEN): $(MYLIB) $(ISDN_OBJS) $(SRC)/ozmod/ozmod_isdn/ozmod_isdn.lo
+	$(LINK) $(SOLINK) $(ISDN_OBJS) $(SRC)/ozmod/ozmod_isdn/ozmod_isdn.o $(MYLIB) -avoid-version -module -rpath $(libdir)
 isdnmod: $(SRC)/ozmod/ozmod_isdn/ozmod_isdn.$(DYNAMIC_LIB_EXTEN)
 
-$(SRC)/ozmod/ozmod_analog/ozmod_analog.$(DYNAMIC_LIB_EXTEN): $(MYLIB) $(SRC)/ozmod/ozmod_analog/ozmod_analog.o
-	$(LINK) $(SOLINK) $(SRC)/ozmod/ozmod_analog/ozmod_analog.o $(MYLIB) -rpath $(libdir)
+$(SRC)/ozmod/ozmod_analog/ozmod_analog.$(DYNAMIC_LIB_EXTEN): $(MYLIB) $(SRC)/ozmod/ozmod_analog/ozmod_analog.lo
+	$(LINK) $(SOLINK) $(SRC)/ozmod/ozmod_analog/ozmod_analog.o $(MYLIB) -avoid-version -module -rpath $(libdir)
 analogmod: $(SRC)/ozmod/ozmod_analog/ozmod_analog.$(DYNAMIC_LIB_EXTEN)
 
-$(SRC)/ozmod/ozmod_analog_em/ozmod_analog_em.$(DYNAMIC_LIB_EXTEN): $(MYLIB) $(ANALOG_EM_OBJS) $(SRC)/ozmod/ozmod_analog_em/ozmod_analog_em.o
-	$(LINK) $(SOLINK) $(SRC)/ozmod/ozmod_analog_em/ozmod_analog_em.o $(MYLIB) -rpath $(libdir)
+$(SRC)/ozmod/ozmod_analog_em/ozmod_analog_em.$(DYNAMIC_LIB_EXTEN): $(MYLIB) $(ANALOG_EM_OBJS) $(SRC)/ozmod/ozmod_analog_em/ozmod_analog_em.lo
+	$(LINK) $(SOLINK) $(SRC)/ozmod/ozmod_analog_em/ozmod_analog_em.o $(MYLIB) -avoid-version -module -rpath $(libdir)
 analog_emmod: $(SRC)/ozmod/ozmod_analog_em/ozmod_analog_em.$(DYNAMIC_LIB_EXTEN)
 
 $(SRC)/ozmod/ozmod_ss7_boost/ozmod_ss7_boost.$(DYNAMIC_LIB_EXTEN): $(MYLIB) $(BOOST_OBJS)
-	$(LINK) $(SOLINK) $(BOOST_OBJS) $(MYLIB) -rpath $(libdir)
+	$(LINK) $(SOLINK) $(BOOST_OBJS) $(MYLIB) -avoid-version -module -rpath $(libdir)
 boostmod: $(SRC)/ozmod/ozmod_ss7_boost/ozmod_ss7_boost.$(DYNAMIC_LIB_EXTEN)
 
 