Index: Makefile.in
===================================================================
--- Makefile.in	(revision 613)
+++ Makefile.in	(working copy)
@@ -49,10 +49,10 @@
 INCS=-I$(OZ_SRCDIR)/$(SRC)/include -I$(OZ_SRCDIR)/$(SRC)/isdn/include -I$(OZ_SRCDIR)/$(SRC)/ozmod/ozmod_ss7_boost 
 CFLAGS+= $(INCS) $(ZAP_CFLAGS) -DZAP_CONFIG_DIR=\"@prefix@/conf\" -DZAP_MOD_DIR=\"@prefix@/mod\"
 
-COMPILE      = $(CC) $(CFLAGS) $(INCS)
+COMPILE   = $(CC) $(CFLAGS) $(INCS)
 LTCOMPILE = $(LIBTOOL) --mode=compile --tag=CC $(COMPILE)
 LINK = $(LIBTOOL) --mode=link --tag=CC $(CCLD) $(CFLAGS) $(LDFLAGS) -o $@
-libdir = $(PREFIX)/lib/
+libdir = $(PREFIX)/lib
 
 SOURCES=\
 $(SRC)/hashtable.c \
@@ -97,45 +97,45 @@
 
 
 OBJS=\
-$(SRC)/hashtable.o \
-$(SRC)/hashtable_itr.o \
-$(SRC)/zap_io.o \
-$(SRC)/zap_config.o \
-$(SRC)/zap_callerid.o \
-$(SRC)/fsk.o \
-$(SRC)/uart.o \
-$(SRC)/g711.o \
-$(SRC)/libteletone_detect.o \
-$(SRC)/libteletone_generate.o \
-$(SRC)/zap_buffer.o \
-$(SRC)/zap_threadmutex.o \
-$(SRC)/zap_dso.o
+$(SRC)/hashtable.lo \
+$(SRC)/hashtable_itr.lo \
+$(SRC)/zap_io.lo \
+$(SRC)/zap_config.lo \
+$(SRC)/zap_callerid.lo \
+$(SRC)/fsk.lo \
+$(SRC)/uart.lo \
+$(SRC)/g711.lo \
+$(SRC)/libteletone_detect.lo \
+$(SRC)/libteletone_generate.lo \
+$(SRC)/zap_buffer.lo \
+$(SRC)/zap_threadmutex.lo \
+$(SRC)/zap_dso.lo
 
 BOOST_OBJS=\
-$(SRC)/ozmod/ozmod_ss7_boost/ss7_boost_client.o \
-$(SRC)/ozmod/ozmod_ss7_boost/ozmod_ss7_boost.o
+$(SRC)/ozmod/ozmod_ss7_boost/ss7_boost_client.lo \
+$(SRC)/ozmod/ozmod_ss7_boost/ozmod_ss7_boost.lo
 
 ISDN_OBJS=\
-$(SRC)/isdn/EuroISDNStateNT.o \
-$(SRC)/isdn/EuroISDNStateTE.o \
-$(SRC)/isdn/mfifo.o \
-$(SRC)/isdn/Q921.o \
-$(SRC)/isdn/Q931api.o \
-$(SRC)/isdn/Q931.o \
-$(SRC)/isdn/Q931ie.o \
-$(SRC)/isdn/Q931mes.o \
-$(SRC)/isdn/Q931StateNT.o \
-$(SRC)/isdn/Q931StateTE.o \
-$(SRC)/isdn/nationalmes.o \
-$(SRC)/isdn/nationalStateNT.o \
-$(SRC)/isdn/nationalStateTE.o \
-$(SRC)/isdn/DMSmes.o \
-$(SRC)/isdn/DMSStateNT.o \
-$(SRC)/isdn/DMSStateTE.o \
-$(SRC)/isdn/5ESSmes.o \
-$(SRC)/isdn/5ESSStateNT.o \
-$(SRC)/isdn/5ESSStateTE.o \
-$(SRC)/isdn/Q932mes.o
+$(SRC)/isdn/EuroISDNStateNT.lo \
+$(SRC)/isdn/EuroISDNStateTE.lo \
+$(SRC)/isdn/mfifo.lo \
+$(SRC)/isdn/Q921.lo \
+$(SRC)/isdn/Q931api.lo \
+$(SRC)/isdn/Q931.lo \
+$(SRC)/isdn/Q931ie.lo \
+$(SRC)/isdn/Q931mes.lo \
+$(SRC)/isdn/Q931StateNT.lo \
+$(SRC)/isdn/Q931StateTE.lo \
+$(SRC)/isdn/nationalmes.lo \
+$(SRC)/isdn/nationalStateNT.lo \
+$(SRC)/isdn/nationalStateTE.lo \
+$(SRC)/isdn/DMSmes.lo \
+$(SRC)/isdn/DMSStateNT.lo \
+$(SRC)/isdn/DMSStateTE.lo \
+$(SRC)/isdn/5ESSmes.lo \
+$(SRC)/isdn/5ESSStateNT.lo \
+$(SRC)/isdn/5ESSStateTE.lo \
+$(SRC)/isdn/Q932mes.lo
 
 
 HEADERS= $(SRC)/include/fsk.h \
@@ -167,7 +167,7 @@
 $(SRC)/isdn/include/Q932.h 
 
 
-MYLIB=libopenzap.$(DYNAMIC_LIB_EXTEN)
+MYLIB=libopenzap.la
 PREFIX=@prefix@
 
 PIKA_DIR=$(shell ls -d /usr/include/pika 2>/dev/null)
@@ -175,7 +175,7 @@
 
 #ifneq ($(PIKA_DIR),)
 #ifneq ($(PIKA_LIB),)
-#OBJS += $(SRC)/zap_pika.o
+#OBJS += $(SRC)/zap_pika.lo
 #CFLAGS += -DZAP_PIKA_SUPPORT -I$(PIKA_DIR)
 #ADD_OBJS = $(PIKA_LIB)
 #endif
@@ -184,36 +184,36 @@
 all: $(MYLIB) analogmod analog_emmod isdnmod boostmod ztmod wpmod
 
 $(MYLIB): $(OBJS) $(HEADERS) $(SOURCES)
-	$(LINK) $(SOLINK) -o $(MYLIB) $(OBJS) $(ADD_OBJS) $(LIBS)
+	$(LINK) $(SOLINK) -o $(MYLIB) $(OBJS) $(ADD_OBJS) $(LIBS) -rpath $(libdir)
 
-testapp: $(SRC)/testapp.o $(MYLIB)
-	$(LINK) $(SRC)/testapp.o ./$(MYLIB) $(LIBS)
+testapp: $(SRC)/testapp.lo $(MYLIB)
+	$(LINK) $(SRC)/testapp.lo ./$(MYLIB) $(LIBS)
 
-testcid: $(SRC)/testcid.o $(MYLIB)
-	$(LINK) $(SRC)/testcid.o ./$(MYLIB) $(LIBS)
+testcid: $(SRC)/testcid.lo $(MYLIB)
+	$(LINK) $(SRC)/testcid.lo ./$(MYLIB) $(LIBS)
 
-testtones: $(SRC)/testtones.o $(MYLIB)
-	$(LINK) $(SRC)/testtones.o ./$(MYLIB) $(LIBS)
+testtones: $(SRC)/testtones.lo $(MYLIB)
+	$(LINK) $(SRC)/testtones.lo ./$(MYLIB) $(LIBS)
 
-detect_tones: $(SRC)/detect_tones.o $(MYLIB)
-	$(LINK) $(SRC)/detect_tones.o ./$(MYLIB) $(LIBS)
+detect_tones: $(SRC)/detect_tones.lo $(MYLIB)
+	$(LINK) $(SRC)/detect_tones.lo ./$(MYLIB) $(LIBS)
 
-detect_dtmf: $(SRC)/detect_dtmf.o $(MYLIB)
-	$(LINK) $(SRC)/detect_dtmf.o ./$(MYLIB) $(LIBS)
+detect_dtmf: $(SRC)/detect_dtmf.lo $(MYLIB)
+	$(LINK) $(SRC)/detect_dtmf.lo ./$(MYLIB) $(LIBS)
 
-testisdn: $(SRC)/testisdn.o $(MYLIB)
-	$(LINK) $(SRC)/testisdn.o ./$(MYLIB) $(LIBS)
+testisdn: $(SRC)/testisdn.lo $(MYLIB)
+	$(LINK) $(SRC)/testisdn.lo ./$(MYLIB) $(LIBS)
 
-testboost: $(SRC)/testboost.o $(MYLIB)
-	$(LINK) $(SRC)/testboost.o ./$(MYLIB) $(LIBS)
+testboost: $(SRC)/testboost.lo $(MYLIB)
+	$(LINK) $(SRC)/testboost.lo ./$(MYLIB) $(LIBS)
 
-testanalog: $(SRC)/testanalog.o $(MYLIB)
-	$(LINK) $(SRC)/testanalog.o ./$(MYLIB) $(LIBS)
+testanalog: $(SRC)/testanalog.lo $(MYLIB)
+	$(LINK) $(SRC)/testanalog.lo ./$(MYLIB) $(LIBS)
 
-$(SRC)/zap_io.o: $(SRC)/zap_io.c
+$(SRC)/zap_io.lo: $(SRC)/zap_io.c
 	$(LTCOMPILE) $(MOD_CFLAGS) -c $< -o $@
 
-%.o: %.c $(HEADERS)
+%.lo: %.c $(HEADERS)
 	$(LTCOMPILE) -c $< -o $@
 
 dox:
@@ -231,55 +231,57 @@
 	@if [ -f mod_openzap/mod_openzap.$(DYNAMIC_LIB_EXTEN) ] ; then cd mod_openzap && make clean ; fi
 
 clean: 
-	rm -f $(SRC)/*.o $(SRC)/isdn/*.o $(MYLIB) *~ \#* testapp testcid testtones detect_tones detect_dtmf testisdn testboost testanalog src/ozmod/*/*.o src/ozmod/*/*.$(DYNAMIC_LIB_EXTEN)
+	rm -f  $(SRC)/*.o $(SRC)/*.lo $(SRC)/isdn/*.o $(SRC)/isdn/*.lo $(MYLIB) *~ \#*
+	rm -rf $(SRC)/.libs $(SRC)/isdn/.libs
+	rm -f  src/ozmod/*/*.o src/ozmod/*/*.lo src/ozmod/*/*.$(DYNAMIC_LIB_EXTEN)
+	rm -rf src/ozmod/*/.libs
+	rm -f  testapp testcid testtones detect_tones detect_dtmf testisdn testboost testanalog
 
 install: all
 	@mkdir -p $(DESTDIR)$(PREFIX)
 	@[ -d "$(DESTDIR)$(PREFIX)/conf" ] || ( mkdir -p $(DESTDIR)$(PREFIX)/conf)
 	@[ -f "$(DESTDIR)$(PREFIX)/conf/openzap.conf" ] || ( cp conf/*.conf $(DESTDIR)$(PREFIX)/conf)
 	@mkdir -p $(DESTDIR)$(PREFIX)/lib
-	@$(LTINSTALL) $(MYLIB) $(DESTDIR)$(PREFIX)/lib/
+	@$(LTINSTALL) $(MYLIB) $(DESTDIR)$(PREFIX)/lib
 	@mkdir -p $(DESTDIR)$(PREFIX)/mod
 	@[ ! -f ozmod_* ] || cp -f ozmod_* $(DESTDIR)$(PREFIX)/mod
-	@cp -f src/ozmod/*/*.$(DYNAMIC_LIB_EXTEN) $(DESTDIR)$(PREFIX)/mod
+	@cp -f src/ozmod/*/.libs/*.$(DYNAMIC_LIB_EXTEN) $(DESTDIR)$(PREFIX)/mod
 	@echo OpenZAP Installed
 
 uninstall:
 	@rm -fr $(DESTDIR)$(PREFIX)
 
-$(SRC)/ozmod/ozmod_skel/ozmod_skel.$(DYNAMIC_LIB_EXTEN): $(SRC)/ozmod/ozmod_skel/ozmod_skel.o $(MYLIB)
-	$(LINK) $(SOLINK) $(SRC)/ozmod/ozmod_skel/ozmod_skel.o $(MYLIB) -rpath $(libdir)
-skelmod: $(SRC)/ozmod/ozmod_skel/ozmod_skel.$(DYNAMIC_LIB_EXTEN)
+$(SRC)/ozmod/ozmod_skel/ozmod_skel.la: $(SRC)/ozmod/ozmod_skel/ozmod_skel.lo
+	$(LINK) $(SOLINK) $(SRC)/ozmod/ozmod_skel/ozmod_skel.lo -avoid-version -module -rpath $(libdir)
+skelmod: $(SRC)/ozmod/ozmod_skel/ozmod_skel.la
 
 
-$(SRC)/ozmod/ozmod_zt/ozmod_zt.$(DYNAMIC_LIB_EXTEN): $(SRC)/ozmod/ozmod_zt/ozmod_zt.o $(MYLIB)
-	$(LINK) $(SOLINK) $(SRC)/ozmod/ozmod_zt/ozmod_zt.o $(MYLIB) -rpath $(libdir)
-ztmod: $(SRC)/ozmod/ozmod_zt/ozmod_zt.$(DYNAMIC_LIB_EXTEN)
+$(SRC)/ozmod/ozmod_zt/ozmod_zt.la: $(SRC)/ozmod/ozmod_zt/ozmod_zt.lo
+	$(LINK) $(SOLINK) $(SRC)/ozmod/ozmod_zt/ozmod_zt.lo -avoid-version -module -rpath $(libdir)
+ztmod: $(SRC)/ozmod/ozmod_zt/ozmod_zt.la
 
-$(SRC)/ozmod/ozmod_wanpipe/ozmod_wanpipe.$(DYNAMIC_LIB_EXTEN): $(SRC)/ozmod/ozmod_wanpipe/ozmod_wanpipe.o $(MYLIB)
-	$(LINK) $(SOLINK) $(SRC)/ozmod/ozmod_wanpipe/ozmod_wanpipe.o $(MYLIB) -rpath $(libdir)
-wpmod: $(SRC)/ozmod/ozmod_wanpipe/ozmod_wanpipe.$(DYNAMIC_LIB_EXTEN)
+$(SRC)/ozmod/ozmod_wanpipe/ozmod_wanpipe.la: $(SRC)/ozmod/ozmod_wanpipe/ozmod_wanpipe.lo
+	$(LINK) $(SOLINK) $(SRC)/ozmod/ozmod_wanpipe/ozmod_wanpipe.lo -avoid-version -module -rpath $(libdir)
+wpmod: $(SRC)/ozmod/ozmod_wanpipe/ozmod_wanpipe.la
 
-$(SRC)/ozmod/ozmod_pika/ozmod_pika.$(DYNAMIC_LIB_EXTEN): $(SRC)/ozmod/ozmod_pika/ozmod_pika.o $(MYLIB)
-	$(LINK) $(SOLINK) $(SRC)/ozmod/ozmod_pika/ozmod_pika.o  $(MYLIB) -rpath $(libdir)
-pikamod: $(SRC)/ozmod/ozmod_pika/ozmod_pika.$(DYNAMIC_LIB_EXTEN)
+$(SRC)/ozmod/ozmod_pika/ozmod_pika.la: $(SRC)/ozmod/ozmod_pika/ozmod_pika.lo
+	$(LINK) $(SOLINK) $(SRC)/ozmod/ozmod_pika/ozmod_pika.lo -avoid-version -module -rpath $(libdir)
+pikamod: $(SRC)/ozmod/ozmod_pika/ozmod_pika.la
 
 $(ISDN_OBJS): $(ISDN_HEADERS) $(ISDN_SOURCES) $(SRC)/ozmod/ozmod_isdn/ozmod_isdn.c
 
-$(SRC)/ozmod/ozmod_isdn/ozmod_isdn.$(DYNAMIC_LIB_EXTEN): $(MYLIB) $(ISDN_OBJS) $(SRC)/ozmod/ozmod_isdn/ozmod_isdn.o
-	$(LINK) $(SOLINK) $(ISDN_OBJS) $(SRC)/ozmod/ozmod_isdn/ozmod_isdn.o $(MYLIB) -rpath $(libdir)
-isdnmod: $(SRC)/ozmod/ozmod_isdn/ozmod_isdn.$(DYNAMIC_LIB_EXTEN)
+$(SRC)/ozmod/ozmod_isdn/ozmod_isdn.la: $(ISDN_OBJS) $(SRC)/ozmod/ozmod_isdn/ozmod_isdn.lo
+	$(LINK) $(SOLINK) $(ISDN_OBJS) $(SRC)/ozmod/ozmod_isdn/ozmod_isdn.lo -avoid-version -module -rpath $(libdir)
+isdnmod: $(SRC)/ozmod/ozmod_isdn/ozmod_isdn.la
 
-$(SRC)/ozmod/ozmod_analog/ozmod_analog.$(DYNAMIC_LIB_EXTEN): $(MYLIB) $(SRC)/ozmod/ozmod_analog/ozmod_analog.o
-	$(LINK) $(SOLINK) $(SRC)/ozmod/ozmod_analog/ozmod_analog.o $(MYLIB) -rpath $(libdir)
-analogmod: $(SRC)/ozmod/ozmod_analog/ozmod_analog.$(DYNAMIC_LIB_EXTEN)
+$(SRC)/ozmod/ozmod_analog/ozmod_analog.la: $(SRC)/ozmod/ozmod_analog/ozmod_analog.lo
+	$(LINK) $(SOLINK) $(SRC)/ozmod/ozmod_analog/ozmod_analog.lo -avoid-version -module -rpath $(libdir)
+analogmod: $(SRC)/ozmod/ozmod_analog/ozmod_analog.la
 
-$(SRC)/ozmod/ozmod_analog_em/ozmod_analog_em.$(DYNAMIC_LIB_EXTEN): $(MYLIB) $(ANALOG_EM_OBJS) $(SRC)/ozmod/ozmod_analog_em/ozmod_analog_em.o
-	$(LINK) $(SOLINK) $(SRC)/ozmod/ozmod_analog_em/ozmod_analog_em.o $(MYLIB) -rpath $(libdir)
-analog_emmod: $(SRC)/ozmod/ozmod_analog_em/ozmod_analog_em.$(DYNAMIC_LIB_EXTEN)
+$(SRC)/ozmod/ozmod_analog_em/ozmod_analog_em.la: $(ANALOG_EM_OBJS) $(SRC)/ozmod/ozmod_analog_em/ozmod_analog_em.lo
+	$(LINK) $(SOLINK) $(SRC)/ozmod/ozmod_analog_em/ozmod_analog_em.lo -avoid-version -module -rpath $(libdir)
+analog_emmod: $(SRC)/ozmod/ozmod_analog_em/ozmod_analog_em.la
 
-$(SRC)/ozmod/ozmod_ss7_boost/ozmod_ss7_boost.$(DYNAMIC_LIB_EXTEN): $(MYLIB) $(BOOST_OBJS)
-	$(LINK) $(SOLINK) $(BOOST_OBJS) $(MYLIB) -rpath $(libdir)
-boostmod: $(SRC)/ozmod/ozmod_ss7_boost/ozmod_ss7_boost.$(DYNAMIC_LIB_EXTEN)
-
-
+$(SRC)/ozmod/ozmod_ss7_boost/ozmod_ss7_boost.la: $(BOOST_OBJS)
+	$(LINK) $(SOLINK) $(BOOST_OBJS) -avoid-version -module -rpath $(libdir)
+boostmod: $(SRC)/ozmod/ozmod_ss7_boost/ozmod_ss7_boost.la
Index: mod_openzap/mod_openzap.c
===================================================================
--- mod_openzap/mod_openzap.c	(revision 613)
+++ mod_openzap/mod_openzap.c	(working copy)
@@ -41,7 +41,7 @@
 
 SWITCH_MODULE_LOAD_FUNCTION(mod_openzap_load);
 SWITCH_MODULE_SHUTDOWN_FUNCTION(mod_openzap_shutdown);
-SWITCH_MODULE_DEFINITION(mod_openzap, mod_openzap_load, mod_openzap_shutdown, NULL);
+SWITCH_MODULE_DEFINITION_EX(mod_openzap, mod_openzap_load, mod_openzap_shutdown, NULL, SMODF_GLOBAL_SYMBOLS);
 
 switch_endpoint_interface_t *openzap_endpoint_interface;
 
Index: mod_openzap/Makefile
===================================================================
--- mod_openzap/Makefile	(revision 613)
+++ mod_openzap/Makefile	(working copy)
@@ -1,7 +1,7 @@
 BASE=../../..
 OZ_DIR=..
 VERBOSE=1
-OZSO=$(OZ_DIR)/libopenzap.so
+OZSO=$(OZ_DIR)/libopenzap.la
 LOCAL_CFLAGS=-I$(OZ_DIR)/src/include -I$(OZ_DIR)/src/isdn/include
 LOCAL_LDFLAGS=-L$(OZ_DIR) -lopenzap 
 include $(BASE)/build/modmake.rules